<template>
<Transition name="fade" appear>
  <div class="unit" :class="{'all-done': allChaptersDone}">
    <div class="unit-title text-shadow">{{title}}
    <transition-group name="fade-fast">
      <div v-if="isEditing" class="plus-btn" @click="addChapterWindow" data-tool="הוסף פרק"></div>
      <div v-if="isEditing" class="x-btn-unit" @click="removeUnit" data-tool="מחק יחידה"></div>
    </transition-group>
    </div>
    <div class="unit-chapters">
      <Chapter v-for="chapter in chapters" :chapter="chapter" :unitid="id" :key="chapter.title" :ref="chapter.id"/>
    </div>
    <ChapterWindow ref="chapterwindow" @done="chapterDone($event)"/>
    <AddChapterWindow v-if="isEditing" ref="addchapterwindow" @add="addChapter($event)"/>
    <EditChapterWindow v-if="isEditing" ref="editchapterwindow" @edit="editChapter($event)"/>
  </div>
</Transition>
</template>

<script>
import Chapter from './chapter.vue'
import ChapterWindow from './chapter-window.vue'
import AddChapterWindow from './add-chapter-window.vue'
import EditChapterWindow from './edit-chapter-window.vue'

export default {
  props: ['title', 'chapters', 'id'],
  mounted() {
    Promise.resolve().then(()=>{
      for (let ref in this.$refs) {
        this.$refs[ref].show = false
      }
      let timeout = 0
      for (let ref in this.$refs) {
        setTimeout(() => {
          this.$refs[ref].show = true
        }, timeout)
        timeout += 50
      }
    })
  },
  methods: {
    chapterWindow(chapter) {
      this.$refs.chapterwindow.popup(chapter)
    },
    removeUnit() {
      if (window.confirm(`למחוק את יחידה: ${this.title} ?`)) {
        this.$store.dispatch('removeUnit', {unitid: this.id})
      }
    },
    addChapterWindow() {
      this.$refs.addchapterwindow.popup()
    },
    editChapterWindow(chapterData) {
      this.$refs.editchapterwindow.popup(chapterData)
    },
    addChapter(chapterData) {
      this.$store.dispatch('addChapter', {unitid: this.id, data: chapterData})
    },
    editChapter(chapterData) {
      this.$store.dispatch('editChapter', {unitid: this.id, data: chapterData})
    },
    chapterDone(id) {
      this.$refs[id].chapterDone(id)
    }
  },
  computed: {
    allChaptersDone() {
      if (this.chapters) {
        let chaptersArr = Object.values(this.chapters)
        return !chaptersArr.find(chapter => !chapter.done)
      } else {
        return false
      }
    },
    isEditing() {
      return this.$store.state.isEditing
    }
  },
  components: {
    Chapter,
    ChapterWindow,
    AddChapterWindow,
    EditChapterWindow
  },
  provide() {
    return {
      chapterWindow: this.chapterWindow,
      editChapterWindow: this.editChapterWindow,
    }
  }
}
</script>

<style scoped>
.unit {
  padding: 2em;
  width: 100%;
  margin: auto;
  display: flex;
  flex-direction: column;
  align-items: center;
}

.unit-title {
  position: relative;
  color: rgb(0, 0, 90);
  background-color: var(--lightBlue);
  border-radius: .5em;
  font-weight: bold;
  text-align: center;
  font-size: 2em;
  width: 100%;
  width: fit-content;
  padding: .5em 1em;
}

.all-done .unit-title {
  background-color: var(--lightGreen);
}

.unit-chapters {
  padding: 2em 0;
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: center;
  flex-wrap: wrap;
}

</style>